#include "stdafx.h"
#include "NPMemoryData.h"

CNPMemoryData::CNPMemoryData(BYTE * pData, unsigned long lDataSize)
{
	m_pData			= new BYTE[lDataSize];
	memcpy(m_pData, pData, lDataSize);
	m_lDataSize		= lDataSize;
	m_lCurrentPos	= 0;
}

CNPMemoryData::~CNPMemoryData(void)
{
	delete [] m_pData;
}


void CNPMemoryData::Seek(unsigned long lSeek)
{
	if(m_lDataSize > lSeek)
		m_lCurrentPos	= lSeek;
}
	
int	CNPMemoryData::ReadData(BYTE *pBuffer, unsigned long lBufferSize)
{
	memcpy(pBuffer, m_pData+m_lCurrentPos, lBufferSize);
	m_lCurrentPos	+= lBufferSize;		

	return lBufferSize;
}
	
void CNPMemoryData::GetLong (unsigned long & lLong)
{
	unsigned long lLow;
	GetShort(lLow);
	
	unsigned long lHigh;
	GetShort(lHigh);
	
	lLow += lHigh << 16;
    lLong = lLow;
}
	
void CNPMemoryData::GetShort (unsigned long & lLong)
{
	int i;
	GetByte(i);
    unsigned long lLow = (unsigned long)i;
    GetByte(i);
    lLow += ((unsigned long)i)<<8;
   	lLong = lLow;
}
	
void CNPMemoryData::GetByte(int & nInt)
{
	unsigned char c;
	c = m_pData[m_lCurrentPos];
	m_lCurrentPos += 1;
	nInt = (int)c;  
}

unsigned long CNPMemoryData::GetZipDataSize()
{
	return m_lDataSize;
}